﻿using System;

namespace ObserverExemplo
{
    public class ConcreteObserver : IObserver
    {
        public string Usuario { get; set; }
        public ConcreteObserver(string nome, ISubject subject)
        {
            Usuario = nome;
            subject.RegistrarObserver(this);
        }

        public void Atualiza(string disponibilidade)
        {
            Console.WriteLine($"Olá {Usuario}, o Produto que você deseja agora " +
                $"esta {disponibilidade} em nosso site");
        }
    }
}
